commit 408fe10442aa53e2b4573abbf0536aa677c92512
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Wed Jul 27 12:06:22 2022 +0200

    cgraphunit: Don't emit asm thunks for -dx [PR106261]
    
    When -dx option is used (didn't know we have it and no idea what is it
    useful for), we just expand functions to RTL and then omit all further
    RTL passes, so the normal functions aren't actually emitted into assembly,
    just variables.
    The following testcase ICEs, because we don't emit the methods, but do
    emit thunks pointing to that and those thunks have unwind info and rely on
    at least some real functions to be emitted (which is normally the case,
    thunks are only emitted for locally defined functions) because otherwise
    there are no CIEs, only FDEs and dwarf2out is upset about it.
    
    The following patch fixes that by not emitting assembly thunks for -dx
    either.
    
    2022-07-27  Jakub Jelinek  <jakub@redhat.com>
    
            PR debug/106261
            * cgraphunit.c (cgraph_node::assemble_thunks_and_aliases): Don't
            output asm thunks for -dx.
    
            * g++.dg/debug/pr106261.C: New test.
    
    (cherry picked from commit f9671b60f9395cb1dca128b92f5dd215f5aeaae1)

diff --git a/gcc/cgraphunit.c b/gcc/cgraphunit.c
index 5071322fec0..93b45ca19a5 100644
--- a/gcc/cgraphunit.c
+++ b/gcc/cgraphunit.c
@@ -2223,7 +2223,7 @@ cgraph_node::assemble_thunks_and_aliases (void)
 	cgraph_node *thunk = e->caller;
 
 	e = e->next_caller;
-	thunk->expand_thunk (true, false);
+	thunk->expand_thunk (!rtl_dump_and_exit, false);
 	thunk->assemble_thunks_and_aliases ();
       }
     else
diff --git a/gcc/testsuite/g++.dg/debug/pr106261.C b/gcc/testsuite/g++.dg/debug/pr106261.C
new file mode 100644
index 00000000000..6dee7e68ff5
--- /dev/null
+++ b/gcc/testsuite/g++.dg/debug/pr106261.C
@@ -0,0 +1,36 @@
+// PR debug/106261
+// { dg-do compile }
+// { dg-options "-dx -fno-dwarf2-cfi-asm" }
+
+struct A
+{
+  virtual void foo ();
+  int a;
+};
+class C : virtual public A
+{
+};
+struct B
+{
+  A *b;
+
+  B (A *x) : b (x) { b->foo (); }
+};
+struct E
+{
+  virtual ~E ();
+};
+class D : public C, E
+{
+};
+struct F : D
+{
+  F (int);
+
+  static void bar ()
+  {
+    F a (0);
+    B b (&a);
+  }
+};
+void baz () { F::bar (); }

